﻿
using System;
using System.Globalization;
using System.IO;
using Wisej.Web;
using Wisej.Web.Ext.DevExtreme;

namespace Wisej.DevExSamples
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void comboBox1_SelectedItemChanged(object sender, EventArgs e)
		{
			var lang = (string)((ComboBox)sender).SelectedItem;

			// change the culture of all dx widgets in the session.
			dxBase.Culture = CultureInfo.GetCultureInfo(lang);

			// optional to change the culture of the session.
			Application.CurrentCulture = CultureInfo.GetCultureInfo(lang);
		}

		private void button1_Click(object sender, EventArgs e)
		{
			this.dxDataGrid1.Instance.addRow();
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			this.dxDataGrid1.Options.dataSource = JSON.Parse(File.ReadAllText(Application.MapPath("App_Data/TestData.json")));

			// Load the pdf extension.
			//Application.LoadPackages(new[] {
			//	new Widget.Package(){
			//		Name = "jspdf",
			//		Source = "https://cdnjs.cloudflare.com/ajax/libs/jspdf/2.3.1/jspdf.umd.min.js"
			//	},
			//	new Widget.Package(){ 
			//		Name = "jspdf.autotable",
			//		Source = "https://cdnjs.cloudflare.com/ajax/libs/jspdf-autotable/3.5.14/jspdf.plugin.autotable.min.js"
			//	}
			//});
		}

		private void dxDataGrid1_WebRequest(object sender, WebRequestEventArgs e)
		{
			switch (e.Request.QueryString["api"])
			{
				case "getDefaultData":
					e.Response.Write(new
					{
						Name = "New Name",
						LastName = "New Last Name"
					}.ToJSON());
					break;

				case "onRowRemoving":
					e.Response.Write(new { 
						errorText = "Sorry, cannot delete this record!"
					}.ToJSON());
					break;
			}
		}

		private async void button2_Click(object sender, EventArgs e)
		{
			var s = await this.dxDataGrid1.Instance.stateAsync();
			AlertBox.Show(s.ToJSON());
		}

		// needs the latest devex.
		private void button3_Click(object sender, EventArgs e)
		{
			Eval(@"
				var doc = new jspdf.jsPDF();
				DevExpress.pdfExporter.exportDataGrid({
					jsPDFDocument: doc,
					component: this.dxDataGrid1.widget

				}).then(function() {
					doc.save('Test.pdf');
				});"
			);
		}
	}
}
